#!/bin/sh
# @(#) 7276.7659

test `uname -s` = Linux && echocmd="echo -e" || echocmd="echo"

yorn ()
{
        YN=b
        while [ "$YN" != "n" -a "$YN" != "no" -a \
                "$YN" != "N" -a "$YN" != "NO" -a \
                "$YN" != "y" -a "$YN" != "yes" -a \
                "$YN" != "Y" -a "$YN" != "YES" -a \
                "$YN" != "Yes" -a "$YN" != "No" ]; do
                $echocmd $1
                read YN
                if [ "$YN" = "y" -o "$YN" = "yes" -o "$YN" = "Yes" -o \
                     "$YN" = "Y" -o "$YN" = "YES" ]; then
                        return 1
                fi
                if [ "$YN" = "n" -o "$YN" = "no" -o "$YN" = "No" -o \
                     "$YN" = "N" -o "$YN" = "NO" ]; then
                        return 0
                fi
                $echocmd "y ܂ n ͂Ă"
        done
}

cont ()
{
        yorn "𑱂܂ (y/n): \c"
        res=$?
        if [ "$res" != "1" ]; then
                exit 0
        fi
}

sep ()
{
$echocmd
$echocmd '--------------------------------------------------------------------------------'
}

set_java_version()
{
  sep
  yorn "COBOL  Java AgĎgp܂ ? (y/n): \c"
  if test $? -eq 1
  then
	sh $COBDIR/bin/java_setup
	else
		$echocmd "Java ZbgAbvXLbv܂B"
		# CK changed the comment for J product
		$echocmd "̃ZbgAbvōs Java  COBOL ƘAg"
		$echocmd "g Java ̃o[WIɂ"
		$echocmd "X[p[[UŎ̃R}hsĂ:"
		$echocmd "  cd $COBDIR; sh ./bin/java_setup"
		cd ${OLDPWD}
		return 0
  fi
}

SCCSid="@(#) install 5.0"

umask 000

#default PATH for COBDIR
DEFCOBDIR=/opt/microfocus/cobol
DEFBIN=/opt/microfocus/bin

BASE=`pwd`
COBDIR=$BASE

if test ! -w /etc/passwd
then
	$echocmd "root łȂ΂̃XNvg͎sł܂"
	exit 1
fi

if [ -f "$COBDIR/etc/mfreg.dat" ]; then
	$echocmd "̃fBNg̐ĩCXg[͊Ɏsς݂łB"
	$echocmd "͖̑Ȃ̂Œ~܂..."
	exit 1
fi

unset COBPATH
unset COBDATA

COBSW=""
export COBSW

$echocmd
$echocmd "̃XNvg Micro Focus Server 5.0 CXg[܂B"
$echocmd
$echocmd "̃[Xɂ́A̐iɊւdvȏLq 2 ̃t@C"
$echocmd "܂܂Ă܂B܂(cpi.htm)́Ã[XŉCꂽ"
$echocmd "̃XgLڂ CPI(Corrected Product Incident:ỉC"
$echocmd "ꂽs)łB(readme.txt)́AV@\Ag@\"
$echocmd "ѐ̏ڍׂLq̂łB̃t@C"
$echocmd "̏ꏊɂ܂ :"
$echocmd
$echocmd "     $COBDIR/docs"
$echocmd
$echocmd "CXg[IɁÃt@CǂނƂ߂܂B"
$echocmd
cont

if test ! -f /tmp/mf_lic_acpt
then
sep
$echocmd "̃\tgEFAiCXg[ĂgpɂȂOɁA"
$echocmd "iɓ̃Gh[Ugp_ (ȉugp_v"
$echocmd "Ƃ) ̏ɍS邱ƂɓӂKv܂B"
$echocmd "gp_͕Kǂ݂B"
$echocmd "gp_ɂӂȂꍇ́A"
$echocmd "gp̐iw̑SւԕiB"
$echocmd "x͂ԋ܂B"
$echocmd "ŐV̎gp_񂪕Kvȏꍇ̓CXg["
$echocmd "sOɂw̑S܂łAB"
$echocmd
yorn "gp_̏ɓӂ܂? (y/n): \c"
clk_ans=$?
if [ "$clk_ans" != "1" ]; then
$echocmd "CZXāACXg[ĊJꍇɂ"
$echocmd "̐ĩCXg[Sł͂Ȃ̂ŁA폜Ă"
$echocmd "߂܂B"
exit 0
fi
else
rm /tmp/mf_lic_acpt
sep
fi

if [ "$1" != "noplatformcheck" ]; then
osname=`uname -s`
if [ ".$osname" = "." ]; then
osname=unknown
fi
oslevel=`lslpp -L|grep "bos.rte " | awk '{print $2}' | cut -c1-5|head -1 2>/dev/null`
if [ ".$oslevel" = "." ]; then
oslevel=`oslevel 2>/dev/null`
fi
if [ ".$oslevel" = "." ]; then
oslevel=unknown
fi
grep "$osname $oslevel" $COBDIR/docs/env.txt >/dev/null 2>&1
rc=$?
if [ "$rc" != "0" ]; then
sep
$echocmd "                Micro Focus CXg["
$echocmd
$echocmd "̐i͂gp̃Iy[eBOVXẽo[Wł̓rh܂eXg"
$echocmd "Ă܂BT|[go[W docs/env.txt ɋLڂĂ܂B"
$echocmd
yorn "̂܂܃CXg[𑱂܂? (y/n): \c"
decision=$?
if [ "$decision" != "1" ]; then
$echocmd "CXg[𒆎~܂B"
exit 98
fi
fi
fi

export COBDIR
cd $COBDIR

# restored for jpn products -- confirmed by JK 2004/06/01
sep
$echocmd "RETURN L[ƁAۏ؊(т̌݊̊)"
$echocmd "ڍׂ\܂B"
$echocmd
$echocmd "ł RETURN L[ĂB: \c"
read ready
$echocmd
more docs/env.txt
$echocmd
$echocmd "L̓ۏ؊̓e"
yorn "܂ (y/n): \c"
env_ans=$?
if [ "$env_ans" != "1" ]; then
$echocmd "ql̗vɂCXg[𒆎~܂B"
exit 0
fi

LD_LIBRARY_PATH=$COBDIR/lib:$LD_LIBRARY_PATH
export LD_LIBRARY_PATH
SHLIB_PATH=$COBDIR/lib:$SHLIB_PATH
export SHLIB_PATH
LIBPATH=$COBDIR/lib:$LIBPATH
export LIBPATH

bin/cobconvstrtest -s
case $? in
        0)      ;;
        1)      sep
		$echocmd "Unicode e[usSłBJ2EE  Web T[rX"
		$echocmd "ɂ Unicode KvȂ߁ÃgUNV"
		$echocmd "@\Ȃ\܂B"
		$echocmd
		yorn "낵ł (y/n): \c" 
                ;;
esac

if test ! -f etc/cobver
then
	sep
	$echocmd "̐iCXg[ɂ COBOL VXe݂ĂKv܂B"
	exit 1
fi

trap "trap "" 0;$echocmd '\n\nCXg[͒~܂B'; exit 1" 2 3 14 15

set -e
trap "$echocmd '\nCXg[G[łB\nfBXN̋󂫗e/`FbNAĎsĂ'; exit 1" 0


DEFLIBDIR=$BASE/lib
lib_update=no
if test -d $DEFLIBDIR
then
        cd $DEFLIBDIR
        for shlib in `ls lib*.?.so 2> /dev/null`
        do
                if test -f $BASE/cobtmp/lib/$shlib*
                then
                        lib_update=yes
                fi
        done
fi
if test $lib_update = yes
then
	$echocmd
        yorn "̋LCuۑ܂? \ñt@C͍XV܂ (y/n): \c"
        save_shlibs=$?
        case $save_shlibs in
        1)  SAVDIR=
                while test ".$SAVDIR" = "."
                do
                        $echocmd
                        $echocmd "CuۑtpX͂"
                        $echocmd "B"
                        $echocmd
		        $echocmd "ۑ̃pX͂ĂB\n܂̓ftHg̃pX ($DEFLIBDIR) \ngpɂ RETURN L[AIɂ q A͂Ă : \c"
			read SAVDIR
                        if test "$SAVDIR" = "q"
                        then
                                $echocmd "\nql̗vɂCXg[𒆎~܂B"
                                trap "" 0
                                exit 1
                        fi
                        SAVDIR=`eval $echocmd $SAVDIR`
                        if test "$SAVDIR." = "."
                        then
                                SAVDIR=$DEFLIBDIR
                        fi
                        if expr "$SAVDIR" : '[^\/]' > /dev/null
                        then
                                $echocmd "'/' Ŏn܂΃pX͂ĂB"
                                SAVDIR=
                                continue
                        fi
                        if test ! -d "$SAVDIR"
                        then
                                yorn "$SAVDIR fBNg݂͑܂B\n쐬܂ ? (y/n): \c"
                                y=$?
                                case "$y" in
                                        1)  mkdir $SAVDIR
                                                chmod 755 $SAVDIR
                                                ;;
                                        *)      SAVDIR=
                                                ;;
                                esac
                                continue
                        fi
                        if test ! -w "$SAVDIR"
                        then
                                $echocmd "$SAVDIR ɏ߂܂B"
                                SAVDIR=
                        fi
                done

                verno=`$echocmd | grep cobol $COBDIR/cobver | \
                sed -e "s/\(cobol v\)\(.\)\.\(.\)\(\..*\)/\2\3/"`
                revno=`$echocmd | grep PRN $COBDIR/cobver | cut -d. -f4`

                $echocmd
                $echocmd "LCuۑ܂ :"
                cd $COBDIR/lib
                for i in `ls lib*.?.?.a`
                do
                        if test -f $BASE/cobtmp/lib/$i*
                        then
                                $echocmd $i
                                cp $COBDIR/lib/$i $SAVDIR/$i.$verno.$revno
                        fi
                done

                $echocmd
                $echocmd "ÂLCũfBNgɕۑ܂:"
                $echocmd " $SAVDIR"
                $echocmd
                $echocmd "ÂLCugp@̓}jAQƂ"
                $echocmd "ĂB"
                ;;
        esac
fi
cd $COBDIR

cd $COBDIR


LIBPATH=/lib:/usr/lib:$COBDIR/lib:$LIBPATH
export LIBPATH

chmod 755 $COBDIR


if test -d $COBDIR/lib
then
	cd $COBDIR/lib

	SEARCHDIR=/usr/lib
	SEARCHDIR2=/lib



	SEARCHFILE=libc


	if test ! -f $SEARCHDIR/$SEARCHFILE.a -a ! -f $SEARCHDIR2/$SEARCHFILE.a
	then
	    if test ! -f $SEARCHDIR/$SEARCHFILE.so -a ! -f $SEARCHDIR2/$SEARCHFILE.so
	    then
		$echocmd
		$echocmd "x: \PbgCu $SEARCHDIR/$SEARCHFILE ܂"
		$echocmd
		$echocmd "CCITCP ͂̃CũT|[gKvƂ܂B ̃CuƃN"
		$echocmd "Ȃ CCITCP ̋@\gpAvP[Vsł܂B"
		$echocmd "̃T|[gKvƂꍇ́ACOBOL VXẽCXg[O"
		$echocmd "TCP/IP Development System CuCXg[Kv܂B"
	    fi

	fi


fi








set +e
trap "" 0



cd $COBDIR


set_java_version



if test -d $COBDIR/lmf
then
sep
$echocmd "̐i Micro Focus CZXǗ@\ (License Management Facility)"
$echocmd "(LMF)gpĕی삳Ă܂BCZXVXeуCZX"
$echocmd "CXg[Ɋւڍׂ́A}jAuJCZXKChv"
$echocmd "QƂĂB"
$echocmd
# RPI 517299 Ensure that the directory /var/mfaslmf exists before
# any LMF install scripts are run.
mkdir -p /var/mfaslmf
chmod 777 /var/mfaslmf
admindir=
$echocmd
$echocmd "LMF CXg[ĂȂA܂ŐṼo[WɃAbvO[h"
$echocmd "ꍇ́ACXg[邱Ƃ𐄏܂B"
$echocmd
yorn "LMF CXg[܂? (y/n): \c"
lmf_ans=$?
case "$lmf_ans" in
	1)  export COBDIR
		LIBPATH=/usr/lib:$COBDIR/lib:$LIBPATH
		export LIBPATH
		LD_LIBRARY_PATH=$COBDIR/lib:$LD_LIBRARY_PATH
                export LD_LIBRARY_PATH
		PATH=$COBDIR/bin:$PATH
		export PATH
		thisd=`pwd`
                cd $COBDIR/lmf
		sh lmfinstall
                cd $thisd
		if [ -f "/tmp/lmfinstalldir" ]; then
			admindir=`cat /tmp/lmfinstalldir`
			lmfinstallok=1
		else
			lmfinstallok=0
		fi
		;;
	*)      $echocmd
	        $echocmd "LMF CXg[ĂȂꍇ́Aȉ̂悤"
		$echocmd "͂ČォCXg[ł܂ :"
                $echocmd "    cd $COBDIR/lmf"
                $echocmd "    sh lmfinstall"
		thisd=`pwd`
		lmfinstallok=-1
                cd $COBDIR/lmf
		admindir=`./lmfgetpv|tail -1|sed "s/Loaded from //"`
		if [ "$admindir" = "License Manager is not running" ]; then
			admindir=
		fi
		cd $thisd
		;;
esac

# Now deal with installation of licenses if we can, and if installer wishes to

$echocmd
$echocmd "CZX̃CXg[@Ɋւڍׂ́A}jA"
$echocmd "uJCZXKChvQƂĂB"
$echocmd 
$echocmd "$COBDIR ɈړĈȉ̃R}hs"
$echocmd "CXg[邱Ƃł܂B"
$echocmd "        sh ./bin/mflicense"
$echocmd

fi


cd $COBDIR

sep
sh ./aslmf/aslmfinstall


modnum=0
if [ -d $COBDIR/dynload64 ]
then
    modnum=1
fi
if [ -d $COBDIR/dynload ]
then
    modnum=`expr $modnum + 2`
fi


sep
case $modnum in

# 32 bit only
    1)  $echocmd "̐i 32 rbg[hł̂ݎgpł܂B" ;
        $COBDIR/bin/cobmode -s 32 ;
        ;;

# 64 bit only
    2)  $echocmd "̐i 64 rbg[hł̂ݎgpł܂B"
        $COBDIR/bin/cobmode -s 64 ;
        ;;

# 32 and 64 bit.
    3)  $echocmd "̐i 32 rbg[hł 64 rbg[hłgpł܂B" ;
        $echocmd "VXẽftHg[hɐݒ肷郂[h 32  64 œ͂Ă: \c" ;
        read mod ;
        while [ "$mod" != "32" -a "$mod" != "64" ]
        do
            $echocmd "Ȓl͂܂B32  64 ̂ǂ炩͂ĂB"
            read mod
        done ;
        $COBDIR/bin/cobmode -s $mod ;
        $echocmd "VXẽftHg COBMODE  $mod ɐݒ肳܂B"
        ;;
esac

if [ -f $COBDIR/docs/html/asdocs.tar ]; then
        sep
        $echocmd "hLgCXg[܂B҂..."
	cd $COBDIR/docs/html
	tar xf asdocs.tar
	rm -f asdocs.tar
        cd $COBDIR
fi

cat >$COBDIR/etc/mfreg.dat <<EOF
SX

SX/5.0

SX/5.0/Interface Mapping Toolkit

SX/5.0/Interface Mapping Toolkit/Version
5.0
SX/5.0/Interface Mapping Toolkit/5.0/Install

SX/5.0/Interface Mapping Toolkit/5.0/Install/SCHEMA
$COBDIR/etc/schema
SX/5.0/Interface Mapping Toolkit/5.0/Install/BIN
$COBDIR/lib
EOF

if [ -f $COBDIR/bin/es_install ]; then
$COBDIR/bin/es_install

if [ -d $COBDIR/src/enterpriseserver/xa ]; then
chmod 777 $COBDIR/src/enterpriseserver/xa
fi
fi

if [ "$2" = "configureopenldap" ]; then
if [ -f "$COBDIR/bin/configure_openldap" ]; then
$COBDIR/bin/configure_openldap <<EOF
y

EOF
fi
fi


sep
if test "$dbcs" = "y"
then
	$echocmd
	$echocmd "EUC ܂ BIG5 R[hZbg DBCS ߐT|[gCXg["
	$echocmd "Ăꍇ́A̐ig߂ɁAK؂ȃfBNg"
	$echocmd "COBDIR ƂĐݒ肵ĂB"
	$echocmd
	$echocmd "W ASCII igɂ́ACOBDIR ƂĈȉݒ肵Ă : "
        $echocmd
	$echocmd "\t$COBDIR"
	$echocmd
	$echocmd " LIBPATH $COBDIR/libA"
	$echocmd "PATH  $COBDIR/bin ǉĂB"
	$echocmd
else
        $echocmd "(YꂸɁA$COBDIR  COBDIR ƂĐݒ肵āA"
        $echocmd "LIBPATH $COBDIR/libA"
        $echocmd "PATH  $COBDIR/bin ǉĂB)"
        $echocmd
fi

$COBDIR/bin/services

$echocmd
$echocmd "x: s\t@C(^CVXe܂̓AvP[V)́A"
$echocmd "̐V[XgpčăNKv܂BăNȂƁA"
$echocmd "V[Xł̋o[W̎s\t@C̎sʂ͕smɂȂ܂B"
$echocmd
$echocmd "CXg[͐I܂B"
$echocmd
$echocmd "COBOL VXegp鏀܂B"
